#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

const int maxn = 100000;

int long_rand()
{
    if (RAND_MAX < maxn) {
        return rand() * rand() + rand();
    } else {
        return rand();
    }
}

int main(int argc, char* argv[])
{
    int n, max_freq, k, randseed;
    istringstream ss1(argv[1]);
    ss1 >> n;
    istringstream ss2(argv[2]);
    ss2 >> max_freq;
    istringstream ss3(argv[3]);
    ss3 >> k;
    istringstream ss4(argv[4]);
    ss4 >> randseed;

    srand(randseed);

    int i, j;
    vector<int> a;
    for (i = 0; i < k; i++)
        for (j = 0; j < max_freq; j++)
            a.push_back(i);
    for (i = max_freq * k; i < n; i++)
        a.push_back(rand() % (26 - k) + k);

    string alfa(26, '.');
    for (i = 0; i < 26; i++)
        alfa[i] = 'a' + i;
    for (i = 0; i < 3*26; i++) {
        int p = rand() % 26;
        int q = rand() % 26;
        swap(alfa[p], alfa[q]);
    }
    string s(n, '.');
    for (i = 0; i < n; i++)
        s[i] = alfa[a[i]];
    for (i = 0; i < 3*n; i++) {
        int p = long_rand() % n;
        int q = long_rand() % n;
        swap(s[p], s[q]);
    }

    cout << s << endl;

    return 0;
}
